/* sidebar.h -- custom widgets for atomic orbitals display.  -*- C++ -*-
   Copyright (C) 2025 Gerardo Ballabio

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <gtkmm.h>

#ifndef __SIDEBAR_
#define __SIDEBAR_

// subclass standard widgets to manage button_press events

class SidebarButton : public Gtk::Button
{
protected:
  virtual bool on_button_press_event(GdkEventButton *event);
  sigc::signal<void(void)> press_signal;
public:
  sigc::signal<void(void)> signal_press() { return press_signal; }
};

class SidebarCheckButton : public Gtk::CheckButton
{
protected:
  virtual bool on_button_press_event(GdkEventButton *event);
  sigc::signal<void(void)> press_signal;
public:
  sigc::signal<void(void)> signal_press() { return press_signal; }
};

class SidebarSpinButton : public Gtk::SpinButton
{
protected:
  virtual bool on_button_press_event(GdkEventButton *event);
  sigc::signal<void(void)> press_signal;
public:
  sigc::signal<void(void)> signal_press() { return press_signal; }
};

#endif /* __SIDEBAR_ */
